#include "Vector.h"
#include "Cheque.h"

int main()
{
    Vector<Cheque *> chq_vec;
    std::string tempname;
    long tempnum;
    double tempbal;
    char kind;
    int chq_num;

    std::cout << "Enter the number of clients: ";
    std::cin >> chq_num;

    for (int i = 0; i < chq_num; i++)
    {
        std::cout << "Enter client's name: ";
        std::cin  >> tempname;
        std::cout << "Enter client's account number: ";
        std::cin >> tempnum;
        std::cout << "Enter opening balance: $";
        std::cin >> tempbal;
        std::cout << "Enter 1 for ChequeBase Account or "
                  << "2 for ChequePlus Account: ";
        while (std::cin >> kind && (kind != '1' && kind != '2'))
            std::cout << "Enter either 1 or 2: ";
        if (kind == '1')
            chq_vec.push_back(new ChequeBase(tempname, tempnum, tempbal));
        else
        {
            double tmax, trate;
            std::cout << "Enter the overdraft limit: $";
            std::cin >> tmax;
            std::cout << "Enter the interest rate "
                      << "as a decimal fraction: ";
            std::cin >> trate;
            chq_vec.push_back(new ChequePlus(tempname, tempnum, tempbal, tmax, trate));
        }
        while (std::cin.get() != '\n')
            continue;
    }

    std::cout << std::endl;
    for (int i = 0; i < chq_num; i++)
    {
        chq_vec[i]->ViewAcct();
        std::cout << std::endl;
        delete chq_vec[i];
    }

    std::cout << "Done." << std::endl;

    return 0;
}